function gaussTest()
%     tic
%     [frames,errors,len,iters,sigmas] = mexGaussTest();
%     toc
%     
%     load('CANORMALF_1000Frames_Errortest.mat');    
% 
%     figure(1)
%     hist(errors(1,:),500);
%     
%     figure(2)
%     hist(errors(2,:),500);
%     
%     
%     figure(3)
%     hist(errors(3,:),500);
%     
%     
%     figure(4)
%     hist(errors(4,:),500);
%     
%     
    load('Sigmatest1000Frames_Errortest.mat'); 
    
    
    step = 100000;
    x = -4:(1/step):4;
    line = zeros(1,length(x));
    
    konst = sqrt(2*pi*(sigmas(1))^2);
    
    r1 = 3100*konst*exp(-((x).^2/(2*(sigmas(1))^2)));
    
    close all;

hold on

    hist(errors(1,:),500);
    plot(x,r1,'r'); 

    hold off

%     
%     figure(6)
%     hist(errors(2,:),500);
%     
%     
%     figure(7)
%     hist(errors(3,:),500);
%     
%     
%     figure(8)
%     hist(errors(4,:),500);
    
%     eval(['saveName = ''Sigmatest' num2str(frames) 'Frames_Errortest'';']);
%     eval(['save ' saveName]);
    
end