%%% The encoder function
% Konvolusjonskoder inngangsdataene%%%
%%%%%%%% Abandoned after decision about implementing all of the turbocode in C %%%%%%%%%%%%%


function [output, endState] = turboEncodeTweak(input, circularState, produceParity)

    switch produceParity
        
        case false

            encoderState = circularState;
            
            len = length(input);

            %%%%% NOTE: need to check the order in which the xor'ing in the recursion
            %%%%% is done, compared to the xoring in the redundancy Y. In the drawing
            %%%%% in the TR document the last bit of the register will nullify itself
            %%%%% in the redundancy, i think.. 

            for i=1:2:len
                % Shift register
                tempReg = encoderState(3);
                encoderState(3) = xor(encoderState(2),input(i+1));
                encoderState(2) = xor(encoderState(1),input(i+1));
                encoderState(1) = xor(xor(input(i),input(i+1)),xor(encoderState(1),tempReg));
            end
            
            output = 0;
            endState = encoderState;
        
        case true
            recursion     = [1 1 0 1]; % 15 octally
            encGeneratorY = [1 0 1 1]; % 13 octally
            encGeneratorW = [1 0 0 1]; % 11 octally

            encoderState = circularState;

            len = length(input);
            channelInput = zeros(2,len);

            for i=1:2:len
                % Systematic bits
                channelInput(1,i) = input(i);
                channelInput(1,i+1) = input(i+1);

                % Redundance bits, just the Y's for now
                tempIn = xor(input(i),input(i+1));
                channelInput(2,i) = xor(tempIn, xor(encoderState(2),encoderState(3)));
                channelInput(2,i+1) = xor(tempIn, encoderState(3));

                % Shift register
                tempReg = encoderState(3);
                encoderState(3) = xor(encoderState(2),input(i+1));
                encoderState(2) = xor(encoderState(1),input(i+1));
                encoderState(1) = xor(tempIn,xor(encoderState(1),tempReg));
            end
            
            output = channelInput;
            endState = encoderState;
    end

end
